/**
 * @flow
 */
'use strict';

import React, { Component } from 'react'
import PropTypes from 'prop-types'

class StaticRenderer extends Component {
  props: {
    shouldUpdate: boolean,
    render: () => React.Element<any>,
  };

  static propTypes = {
    shouldUpdate: PropTypes.bool.isRequired,
    render: PropTypes.func.isRequired,
  };

  shouldComponentUpdate(nextProps: { shouldUpdate: boolean }): boolean {
    return nextProps.shouldUpdate;
  }

  render(): React.Element<any> {
    return this.props.render();
  }
}

module.exports = StaticRenderer;
